<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.DateUtil"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.error.ThrowableUtil"
	import="net.sf.basedb.util.extensions.ActionIterator"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.util.extensions.ExtensionsFilter"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.extensions.Registry"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.service.ServiceControllerAction"
	import="net.sf.basedb.clients.web.extensions.service.Services"
	import="net.sf.basedb.util.extensions.logging.ExtensionsLog"
	import="net.sf.basedb.util.extensions.logging.LogEntry"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.util.Date"
	import="java.util.Iterator"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String xtId = Values.getString(request.getParameter("extensionId"));
final boolean autoUpdate = Values.getBoolean(request.getParameter("autoUpdate"));
Extension ext = ExtensionsControl.get(null).getExtension(xtId);
ExtensionsLog serviceLog = ExtensionsLog.getLog(ext.getId(), true);
try
{
%>
	<base:page type="popup" title="View log" id="view-page">
	<base:head scripts="table.js,~view_log.js" styles="table.css,toolbar.css">
		<style>
		.level
		{
			width: 5em !important;
			min-width: 5em !important;
			text-align: right;
			font-weight: bold;
		}
		.level > span
		{
			margin-left: 0.5em;
			margin-right: 0.25em;
		}
		.timestamp
		{
			width: 15em !important;
			text-align: center !important;
		}
		.stacktrace
		{
			white-space: pre-wrap !important;
		}
		</style>
	</base:head>
	<base:body data-read-only="1">
	<h1>Event log - <%=ext.getAbout().getName()%></h1>
	
	<div id="page-data" data-extension-id="<%=HTML.encodeTags(xtId)%>"></div>
	
	<div class="content">
		<tbl:table 
			id="services"
			subclass="fulltable topborder"
			columns="all"
			stickyheaders="<%=null%>"
			>
			<tbl:columndef 
				id="level"
				title="" 
				subclass="level"
			/>
			<tbl:columndef 
				id="timestamp"
				title="Time" 
				subclass="timestamp"
			/>
			<tbl:columndef 
				id="message"
				title="Message" 
			/>
			<div class="panelgroup bg-filled-50 bottomborder" style="height: 1.9em;">
				<tbl:toolbar>
					<tbl:button
						id="btnUpdate"
						title="Update"
						image="refresh.png"
						tooltip="Re-load this page"
					/>
					<tbl:button
						id="btnClearLog"
						title="Clear the log"
						image="delete.png"
						tooltip="Delete all entries from the log"
					/>
					<tbl:label style="padding-right: 1em;">
						<label><input type="checkbox" name="enableDebug" 
							id="enableDebug" <%=serviceLog.isDebugEnabled()?"checked":""%>
							>Enable debug logging</label>
					</tbl:label>
					<tbl:label style="padding-right: 1em;">
						<label title="All log entries are copied to the regular log file (including TRACE-level entries)"
							><input type="checkbox" name="copyToStdout" 
							id="copyToStdout" <%=serviceLog.isCopyingToStdout()?"checked":""%>
							>Copy to stdout</label>
					</tbl:label>
					<tbl:label style="padding-right: 1em;">
						<label><input type="checkbox" name="autoUpdate"
							id="autoUpdate" <%=autoUpdate?"checked":"" %>
							>Auto update</label>
					</tbl:label>
				</tbl:toolbar>
			</div>
			<tbl:data style="top: 1.9em; margin-top: 0px;">
				<tbl:headers>
					<tbl:headerrow>
						<tbl:columnheaders />
					</tbl:headerrow>
				</tbl:headers>
				<tbl:rows>
				<%
				Iterator<LogEntry> it = serviceLog.getLogEntries();
				int entryNo = 0;
				while (it.hasNext())
				{
					entryNo++;
					LogEntry e = it.next();
					Throwable stacktrace = e.getStacktrace();
					%>
					<tbl:row>
						<tbl:cell column="level" subclass="level"><%=entryNo%><base:icon image="<%=e.getLevel().getIcon()%>"/></tbl:cell>
						<tbl:cell column="timestamp" subclass="timestamp"><%=DateUtil.formatTimestamp(e.getDate()) %></tbl:cell>
						<tbl:cell column="message"><%=HTML.encodeTags(e.getMessage()) %>
							<%
							if (stacktrace != null)
							{
								%>
								<base:icon 
									id="<%="toggle-stacktrace."+entryNo%>" subclass="auto-init" 
									data-auto-init="toggle-stacktrace"
									data-extension-id="<%=entryNo%>"
									tooltip="Click to show full stacktrace"
									image="gonext.png"
								/>
								<div id="stacktrace.<%=entryNo%>"
										class="stacktrace messagecontainer error"
										style="display: none;"
									><%=ThrowableUtil.stackTraceToString(stacktrace)%></div>
								<%
							}
							%>
						</tbl:cell>
					</tbl:row>
					<%
				}
				if (entryNo == 0)
				{
					%>
					<tbl:panel subclass="bg-filled-50">
						<div class="messagecontainer note">
						No entries in this log.
						</div>
					</tbl:panel>
					<%
				}
				%>
				</tbl:rows>
			</tbl:data>
		</tbl:table>
	</div>
		<base:buttongroup subclass="dialogbuttons">
			<base:button id="close" title="Close" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	
}
%>
