/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/
'use strict';

var History = function()
{
	var history = {};
	var loaded = false;
	
	/**
		Initialize the page.
	*/
	history.initPage = function()
	{
		var pageId = Doc.getPageId();
		if (pageId == 'view-history')
		{
			// Buttons
			Buttons.addClickHandler('close', App.closeWindow);
		}
		else if (pageId == 'list-history')
		{
			var attributes = {'item-type': 'CHANGEHISTORY'};
			var tableAttributes = {'table-id': 'history'};
			Buttons.addClickHandler('btnColumns', Buttons.configureColumns, tableAttributes);
			Buttons.addClickHandler('btnExport', Buttons.runListPlugin, tableAttributes);

		}
		else
		{
			// Iframe included on single-item view page of other items
		}
	}
	
	history.loadOnce = function()
	{
		if (loaded) return;
		var url = App.getRoot() + 'common/history/index.jsp?ID='+App.getSessionId();
		url += '&cmd=List';
		url += '&source_type='+Data.get('history-data', 'source-type');
		url += '&source_id='+Data.get('history-data', 'source-id');
		url += '&transact_id='+Data.get('history-data', 'transact-id');
		frames['history-frame'].location.replace(url);
		loaded = true;
	}

	history.initElements = function(element, autoInit)
	{
		if (autoInit == 'transact-box')
		{
			Events.addEventHandler(element, 'mouseenter', history.mouseEnterTransactBox);
			Events.addEventHandler(element, 'mouseleave', history.mouseLeaveTransactBox);
		}
		else if (autoInit == 'transact-link')
		{
			Events.addEventHandler(element, 'click', history.viewTransaction);
		}
	}
	
	history.viewTransaction = function(event)
	{
		var url = App.getRoot()+Items.getController('SESSION').url + '?ID='+App.getSessionId();
		url += '&cmd=ViewTransaction&item_id='+Data.get(event.currentTarget, 'session-id');
		url += '&transact_id='+Data.get(event.currentTarget, 'transact-id');
		window.parent.location.href = url;
	}
	
	history.mouseEnterTransactBox = function(event)
	{
		Doc.addClass('history', 'transact-'+Data.get(event.currentTarget, 'transact-id'));
	}
	
	history.mouseLeaveTransactBox = function(event)
	{
		Doc.removeClass('history', 'transact-'+Data.get(event.currentTarget, 'transact-id'));
	}

	return history;
}();
Doc.addElementInitializer(History.initElements);
Doc.onLoad(History.initPage);